
beforeSave = "", //保存前数据
    /**
     * 描述：周期季度 单据头表单校验
     */
    shr.defineClass("shr.custom.ExamineGradePersonZQJDEdit", shr.framework.Edit, {

        /**
         * 描述:初始化操作
         * 
         * @action
         */
        initalizeDOM: function () {
            var _self = this;
            shr.custom.ExamineGradePersonZQJDEdit.superClass.initalizeDOM.call(this);
            if (this.getOperateState().toUpperCase() != 'view') {
                _self.periodTypeChange();
            }
            _self.entrysInital();
            beforeSave = $("#entrys").jqGrid('getRowData');
            _self.initEditGridToolBar();
        },
        /**
             * 初始化editGrid的按钮
             */
        initEditGridToolBar: function () {
            var self = this;
            var importBtnHtml = $("<button id='import_entrys' type='button' class='shrbtn-primary shrbtn' name='import'>导入</button>");
            $('#deleteRow_entrys').css("margin-left", "4px");
            importBtnHtml.insertBefore($('#deleteRow_entrys'));
            $('#import_entrys').shrButton({
                actionBinding: 'importAction',
                subAction: '',
                customData: ""
            });
        },
        /**
         * 删除行
         */
        deleteRowAction: function (event) {

            var _self = this;
            var $editGrid = this.getEditGrid(event.currentTarget);
            var ids = $editGrid.jqGrid('getSelectedRows');
            if (ids.length > 0) {
                shr.showConfirm($.shrI18n.common.tips.deleteConfirm, function () {
                    _self.remoteCall({
                        method: 'customDelete',
                        param: {
                            idArray: ids + "",
                        },
                        success: function (data) {
                            shr.showInfo({
                                message: "刪除成功",
                                history: 0.7
                            });
                            setTimeout(function () {
                                location.reload();
                            }, 2000); // 2000 毫秒即为两秒钟
                        }, error: function (response) {
                            shr.showError({
                                message: response.summary,
                                history: 2
                            });
                        }
                    });

                });
            } else {
                shr.showWarning({
                    message: $.shrI18n.common.tips.chooseTableDataFirst
                });
            }

        },


        /**
         * 导入
         */
        importAction: function () {
            var _self = this;
            //		self.importDoAction();
            var uipk = shr.getUrlRequestParam("uipk");
            var serviceId = shr.getUrlRequestParam("serviceId");
            btnName = 'import';
            var callback = function (data) {
                if (data && data.length > 0) {
                    var $editGrid = $("#entrys");
                    var entryDatas = $editGrid.jqGrid('getRowData');
                    var exist = false;
                    for (var i = 0; i < data.length; i++) {
                        entry = data[i];
                        // entry.index = 0;
                        entry.orderStatuc = 2;
                        // exist = false;
                        // if (entryDatas.length) {
                        //     $.each(entryDatas, function (i, value) {
                        //         if (value.person.id == entry.person.id) {
                        //             exist = true;
                        //             return;
                        //         }
                        //     });
                        // }
                        // if(!exist){
                        var newRowId = _self.findNextId($editGrid);
                        $editGrid.jqGrid("addRowData", newRowId, entry, "last");
                        // //暂存员工信息
                        // var personInfoObj = {};
                        // personInfoObj["empType"] = entry.oldEmpType;
                        // self._personInfos[entry.person.id] = personInfoObj;

                        // //暂存导入员工信息(用于多人离职单使用)
                        // self.bizDateList[entry.person.id] = entry.bizDate;
                        // if(entry.bizDate){
                        //     var date = new Date(entry.bizDate);
                        //     var bizDate = date.format("yyyy-MM-dd");
                        //     self.bizDateList[entry.person.id] = bizDate;
                        // }else{
                        //     self.bizDateList[entry.person.id]="";
                        // }
                        //设置控制权限
                        // self.setSpecialCtrlCols(self.getEditRowValue("hrBizDefine",newRowId),newRowId);
                        // self.initEditEntrysCustomData(entry,newRowId);
                        // self.initDataFromStructure(newRowId,entry.person.id);
                        // }
                    }
                }
            }
            shr.doImportExcel({ btnName: btnName, uipk: uipk, serviceId: serviceId, customParam: { billId: shr.getUrlRequestParam('billId') } }, callback);
        },
        /**
             * 生成新的rowId
             */
        findNextId: function () {
            var self = this;
            var maxId = 0;
            $("#entrys").find("tr").each(function () {
                var id = $(this).attr("id");
                if (/^[0-9]*$/.test(id)) {//如果ids[i]是纯数字则认为是未保存时生成的临时行序号，进行比较，不加这个判断数字开头的id也能成功parseInt()
                    try {
                        id = parseInt(id);
                        if (id > maxId) {
                            maxId = id;
                        }
                    } catch (e) {
                    }
                }
            });
            maxId = parseInt(maxId) + 1;
            return maxId;
        },

        entrysInital: function () {
            var entrys = waf("#entrys");
            entrys.jqGrid("option", {
                afterEditCell: function (rowid, cellname, value, iRow, iCol) {
                    //部门
                    $('#' + iRow + '_adminOrg').shrPromptBox("option", {
                        onchange: function (e, val) {
                            if (cellname == "adminOrg") {
                                $("#entrys").jqGrid('setCell', rowid, "adminOrg.number", val.current["number"]);//员工编码
                                $("#entrys").jqGrid('setCell', rowid, "orderStatuc", "2");//员工编码
                            }

                        }
                    });
                    $('#' + iRow + '_auditor').shrPromptBox("option", {
                        onchange: function (e, val) {
                            if (cellname == "auditor") {
                                $("#entrys").jqGrid('setCell', rowid, "auditor.number", val.current["number"]);//员工编码
                            }

                        }
                    });
                    $('#' + iRow + '_scorer').shrPromptBox("option", {
                        onchange: function (e, val) {
                            if (cellname == "scorer") {
                                $("#entrys").jqGrid('setCell', rowid, "scorer.number", val.current["number"]);//员工编码
                            }
                        }
                    });

                    $("#" + iRow + "_expireTime").attr("placeholder", "请点击选择到期时间(必填）");
                },
                beforeSaveCell: function (rowid, cellname, value, iRow, iCol) {

                },
                afterSaveCell: function (rowid, cellname, value, iRow, iCol) {

                },
                beforeEditCell: function (rowid, cellname, value, iRow, iCol) {
                }
            });
        },

        /**
       * 启动排序
       */
        startOrderAction() {
            var _self = this;
            var billId = shr.getUrlRequestParam("billId");
            var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.handler.ExamineZQJDEditHandler&method=startOrder";
            _self.remoteCall({
                method: 'startOrder',
                param: {
                    billId: billId,
                },
                success: function (data) {
                    shr.showInfo({
                        message: "已启动排序",
                        history: 2
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 2000); // 2000 毫秒即为两秒钟
                }, error: function (response) {
                    shr.showError({
                        message: response.summary,
                        history: 2
                    });
                }
            });

        },
        /**
         * 组织维护得分表
         */
        performanceScoreOrgAction() {
            //获取周期季度ID
            var billId = shr.getUrlRequestParam("billId");
            this.reloadPage({
                uipk: "PerformanceScore.form",
                billId: billId,
                method: 'edit'
            });
        },
        /**
         * 锁定周期
         */
        periodLockAction() {
            var _self = this;
            var billId = shr.getUrlRequestParam("billId");
            _self.remoteCall({
                method: 'periodLock',
                param: {
                    billId: billId,
                },
                success: function (data) {
                    shr.showInfo({
                        message: "已锁定周期",
                        history: 2
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 2000); // 2000 毫秒即为两秒钟
                }, error: function (response) {
                    shr.showError({
                        message: response.summary
                    });
                }
            });

        },
        /**
         * 解除周期
         */
        periodUnlockAction() {
            var _self = this;
            var billId = shr.getUrlRequestParam("billId");
            var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.eas.custom.performancenew.handler.ExamineZQJDEditHandler&method=periodUnlock";
            _self.remoteCall({
                method: 'periodUnlock',
                param: {
                    billId: billId,
                },
                success: function (data) {
                    shr.showInfo({
                        message: "已解除周期",
                        history: 2
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 2000); // 2000 毫秒即为两秒钟
                }, error: function (response) {
                    shr.showError({
                        message: response.summary,
                        history: 2
                    });
                }
            });



        },
        //周期类型事件触发
        periodTypeChange: function () {
            var _self = this;
            $("#periodType").change(function () {
                var periodType = $("#periodType").val();
                if (periodType == "年度") {
                    $("#quarter").shrTextField('disable');//或者设为enable
                } else {
                    $("#quarter").shrTextField('enable');//或者设为disable
                }
                console.log(periodType);
            })
            var periodType = $("#periodType").val();
            if (periodType == "年度") {
                $("#quarter").shrTextField('disable');//或者设为enable
            } else {
                $("#quarter").shrTextField('enable');//或者设为disable
            }
            if (this.getOperateState().toUpperCase() == 'EDIT') {
                $("#year").shrTextField('disable');//或者设为enable
            }
        },

        /**
         * 保存
         */
        saveAction: function (event) {
            $("#entrys").jqGrid("editStop");
            var periodType = $("#periodType").val();
            var year = $("#year").val();
            if (periodType == "年度") {
                var validYear = this.validateYear(year);
                if (!validYear) {
                    shr.showWarning({
                        message: '请输入有效年',
                        history: 2

                    });
                    return;
                }
            } else {
                var quarter = $("#quarter").val();
                var validYearMonth = this.validateYearMonth(year, quarter);
                if (!validYearMonth) {
                    shr.showWarning({
                        message: '请输入有效年或季度',
                        history: 2
                    });
                    return;
                }
            }
            shr.custom.ExamineGradePersonZQJDEdit.superClass.saveAction.call(this);
        },


        /**
     * 组装保存时传至服务端的数据
     */
        assembleSaveData: function (action) {
            var _self = this;
            var data = _self.prepareParam(action + 'Action');
            var billId = shr.getUrlRequestParam("billId");
            data.method = action;
            if (billId == "") {
                data.saveType = action;
            } else {
                data.saveType = "edit";
            }

            data.operateState = _self.getOperateState();

            data.model = shr.toJSON(_self.assembleModel());
            console.log(beforeSave);
            var afterSave = $("#entrys").jqGrid('getRowData');
            console.log(afterSave);
            data.beforeSave = JSON.stringify(beforeSave);;
            data.afterSave = JSON.stringify(afterSave);
            // relatedFieldId
            var relatedFieldId = this.getRelatedFieldId();
            if (relatedFieldId) {
                data.relatedFieldId = relatedFieldId;
            }


            return data;
        },

        /**
         * 校验有效年
         */
        validateYear: function (year) {
            // 验证年份和月份的格式
            var yearPattern = /^\d{4}$/;
            if (!yearPattern.test(year)) {
                return false; // 年份或者月份格式不正确
            }

            // 构建 Date 对象
            var date = new Date(year);

            // 校验日期的有效性
            if (date.getFullYear() !== parseInt(year)) {
                return false; // 日期不在该年月的有效范围内
            }

            return true; // 年有效
        },
        /**
             * 校验是否有效年或季度
             */
        validateYearMonth: function (year, month) {
            // 验证年份和月份的格式
            var yearPattern = /^\d{4}$/;
            var monthPattern = /^[1-4]$/;

            if (!yearPattern.test(year) || !monthPattern.test(month)) {
                return false; // 年份或者月份格式不正确
            }

            // 构建 Date 对象
            var date = new Date(year);

            // 校验日期的有效性
            if (date.getFullYear() !== parseInt(year)) {
                return false; // 日期不在该年月的有效范围内
            }

            return true; // 年月有效
        }
    });
