package com.kingdee.eas.custom.notify;

import com.kingdee.bos.framework.ejb.EJBRemoteException;
import com.kingdee.bos.util.BOSObjectType;
import java.rmi.RemoteException;
import com.kingdee.bos.framework.AbstractBizCtrl;
import com.kingdee.bos.orm.template.ORMObject;

import com.kingdee.eas.custom.notify.app.*;
import com.kingdee.bos.util.*;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.framework.DataBase;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.IDataBase;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import java.lang.String;
import com.kingdee.bos.framework.*;

public class UpdateContent extends DataBase implements IUpdateContent
{
    public UpdateContent()
    {
        super();
        registerInterface(IUpdateContent.class, this);
    }
    public UpdateContent(Context ctx)
    {
        super(ctx);
        registerInterface(IUpdateContent.class, this);
    }
    public BOSObjectType getType()
    {
        return new BOSObjectType("683EDED6");
    }
    private UpdateContentController getController() throws BOSException
    {
        return (UpdateContentController)getBizController();
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@return
     */
    public UpdateContentInfo getUpdateContentInfo(IObjectPK pk) throws BOSException, EASBizException
    {
        try {
            return getController().getUpdateContentInfo(getContext(), pk);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@param selector ȡֵ
     *@return
     */
    public UpdateContentInfo getUpdateContentInfo(IObjectPK pk, SelectorItemCollection selector) throws BOSException, EASBizException
    {
        try {
            return getController().getUpdateContentInfo(getContext(), pk, selector);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param oql ȡֵ
     *@return
     */
    public UpdateContentInfo getUpdateContentInfo(String oql) throws BOSException, EASBizException
    {
        try {
            return getController().getUpdateContentInfo(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@return
     */
    public UpdateContentCollection getUpdateContentCollection() throws BOSException
    {
        try {
            return getController().getUpdateContentCollection(getContext());
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param view ȡ
     *@return
     */
    public UpdateContentCollection getUpdateContentCollection(EntityViewInfo view) throws BOSException
    {
        try {
            return getController().getUpdateContentCollection(getContext(), view);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param oql ȡ
     *@return
     */
    public UpdateContentCollection getUpdateContentCollection(String oql) throws BOSException
    {
        try {
            return getController().getUpdateContentCollection(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
}